
;DEF FN f(a$,b$,a)=USR a ... FN f("a","b",find)
;find array 'a' [& optionally rename as 'b']
;DEF FN f(a$,b$,a)=USR a ... FN f("a","b",fill)
;fill array 'a' elements with value 'b'
;DEF FN c(a,b,l,c$)=USR copy ... FN c(a,b,l,"c")
;[optionally copy string 'c' to 'a' then] copy 'l' bytes from 'a' to 'b' (may overlap)

;array name form: "a()" or "a$()"
;'a','b','c' may be any appropriate numeric or string expression

;copy may be used to fill with a recurring pattern; eg.
;FN c(50000,50004,996,"wxyz")
;will fill 50000-50999 with "wxyz" recurring
;If no initialisation string is defined then copy will start from
;the top or bottom end as appropriate, depending on the relative
;positions of 'a' & 'b', in order to preserve the source data at the
;destination in case the two areas overlap; ie. it effectively does
;a shift up or down as appropriate.

SCANNG: equ  $24fb           ;subroutine SCANNING
LOOKVA: equ  $28b2           ;subroutine LOOK_VARS
STORES: equ  $2ab6           ;calculator stack: from AEDCB
FETCHS: equ  $2bf1           ;calculator stack:   to AEDCB
STAKA:  equ  $2d28           ;calculator stack: from A
STAKBC: equ  $2d2b           ;calculator stack: from BC
FPTOBC: equ  $2da2           ;calculator stack:   to BC
FPTOA:  equ  $2dd5           ;calculator stack:   to A
STKNUM: equ  $33b4           ;calculator stack: from FP at HL->HL+4

DEFADD: equ  23563
CH_ADD: equ  23645
MEMBOT: equ  23698

LOCATE: equ  65000           ;***
        org  LOCATE


;initialisation: RANDOMIZE USR initsr
INITSR: ld   h,b
        ld   l,c        ;HL=runtime   location
        ld   de,LOCATE  ;DE=assembled location
        and  a
        sbc  hl,de
        push hl         ;HL=runtime displacement from LOCATE
        pop  bc         ;BC=runtime displacement from LOCATE
        ld   hl,FINDAR  ;--->adjust FINDAR call addresses
        add  hl,bc
        ex   de,hl
        ld   hl,CALL1+1
        add  hl,bc
        ld   (hl),e
        inc  hl
        ld   (hl),d     ;<---
        ld   hl,CALL2+1
        add  hl,bc
        ld   (hl),e
        inc  hl
        ld   (hl),d     ;<---
        ret


FINDAR: ld   e,(IX+4)
        ld   d,(IX+5)   ;DE=address (of array name)
        ld   bc,(CH_ADD)
        push bc
        ld   (CH_ADD),de
        call LOOKVA     ;if found: Carry reset, HL=address; otherwise: Carry set
        ld   a,c        ;A =discriminator byte; bits 6&5 indicate variable type
        pop  bc
        ld   (CH_ADD),bc
        ret  c          ;return if not found
        push hl         ;HL=address of array
        inc  hl
        ld   e,(hl)
        inc  hl
        ld   d,(hl)     ;DE=1+ length of dims+elements
        inc  hl
        ld   b,(hl)     ;B =number of dimensions
        inc  hl
        dec  de
ADDUPD: inc  hl
        dec  de
        inc  hl
        dec  de
        djnz ADDUPD
        ld   b,d
        ld   c,e        ;BC=total size of array elements
        ex   de,hl      ;DE=address of array's 1st element
        pop  hl         ;HL=address of array
        and  a          ;reset Carry
        ret


;DEF FN f(a$,b$,a)=USR a ... FN f("a","b",find)
;"a" "$" 0E nn nn nn nn nn "," "b" "$" 0E nn ee dd cc bb "," "a" 0E nn nn nn nn nn ")"
; 0   1   2  3  4  5  6  7  8   9  10  11 12 13 14 15 16 17  18  19 20 21 22 23 24 25
FIND:   ld   ix,(DEFADD)
        ld   c,(ix+15)
        ld   b,(ix+16)    ;BC=length of new name
        ld   a,c
        add  a,b
        inc  a
        cp   1
        jr   z,CALL1-1
        ld   e,(ix+13)
        ld   d,(ix+14)     ;DE=address of new name
        ld   a,(de)
        push af
CALL1:  call FINDAR     ;***
        pop  bc
        jp   c,$1C2E    ;"2 Variable not found"
        push HL         ;HL=address of array
        ld   a,b
        cp   1
        jr   z,NOCHNG   ;jump if no change
        pop  HL
        cp   $61        ;compare "a"
        jr   c,CHECKA
        sub  $20
CHECKA: cp   $41        ;compare "A"
        jr   c,CHECK0
        sub  $40
CHECK0: cp   $1B
        jp   nc,$34E7   ;"A Invalid argument"
        ld   b,a
        ld   a,$E0
        and  (hl)
        add  a,b
        ld   (hl),a
        push hl
NOCHNG: pop  BC         ;BC=address of array
        ret


;DEF FN f(a$,b$,a)=USR a ... FN f("a","b",fill)
;fill array 'a' elements with value 'b'
;"a" "$" 0E nn nn nn nn nn "," "b" "$" 0E nn ee dd cc bb "," "a" 0E nn nn nn nn nn ")"
; 0   1   2  3  4  5  6  7  8   9  10  11 12 13 14 15 16 17  18  19 20 21 22 23 24 25
FILL:   ld   ix,(DEFADD)
CALL2:  call FINDAR     ;***
        jp   c,$1C2E    ;"2 Variable not found"
        ld   a,(ix+6)   ;A =array name length including ()
        cp   5
        jp   nc,$34E7   ;"A Invalid argument"
        cp   3
        jp   c,$34E7    ;"A Invalid argument"
        push bc      ;1>;BC=total size of array elements
        push de      ;2>;DE=address of array's 1st element
        ld   e,(ix+13)
        ld   d,(ix+14)     ;DE=fill value address
        ld   c,(ix+15)
        ld   b,(ix+16)     ;BC=fill value length
        cp   4
        jr   z,FILL2    ;jump if character array
        push ix
        pop  hl
        ld   bc,12
        add  hl,bc
        call STKNUM     ;stack fill value
        ld   b,$1D
        rst  $28
        defb $1D,$38    ;VAL fill value
        call FETCHS
        ld   hl,MEMBOT+4
        ld   (hl),b
        dec  hl
        ld   (hl),c
        dec  hl
        ld   (hl),d
        dec  hl
        ld   (hl),e
        dec  hl
        ld   (hl),a
        ld   bc,5
        ex   de,hl
FILL2:  ex   de,hl      ;HL=fill value address
        pop  de      ;2<;DE=address of array's 1st element
        push de      ;2>
        push bc      ;3>
        ldir            ;copy fill value to 1st element
        pop  bc      ;3<;BC=size of fill value
        pop  af      ;2<;AF=address of array's 1st element
        pop  hl      ;1<;HL=total size of array elements
        push af      ;1>
        and  a
        sbc  hl,bc
        ld   b,h
        ld   c,l        ;BC=size of unfilled segment
        pop  hl      ;1<;HL=address of array's 1st element
        ldir
        ret


;DEF FN c(a,b,l,c$)=USR copy ... FN c(a,b,l,"c")
;[optionally copy string 'c' to 'a' then] copy 'l' bytes from 'a' to 'b' (may overlap)
;"a" 0E nn nn nn nn nn "," "b" 0E nn nn nn nn nn "," "l" 0E nn nn nn nn nn "," "c" "$" 0E nn ee dd cc bb ")"
; 0   1  2  3  4  5  6  7   8   9 10 11 12 13 14 15  16  17 18 19 20 21 22 23  24  25  26 27 28 29 30 31 32
COPY:   ld   ix,(DEFADD)
        ld   hl,(DEFADD)
        inc  hl
        inc  hl
        call STKNUM
        call FPTOBC
        ld   d,b
        ld   e,c        ;DE=copy from address
        ld   l,(ix+28)
        ld   h,(ix+29)  ;HL=initialisation string address
        ld   c,(ix+30)
        ld   b,(ix+31)  ;BC=initialisation string length
        push de
        ld   a,b
        or   c
        push af
        jr   z,COPY3
        ldir            ;copy initialisation string
COPY3:  ld   hl,(DEFADD)
        push hl
        ld   bc,10
        add  hl,bc
        call STKNUM
        call FPTOBC     ;BC=copy to address
        pop  hl
        push bc
        ld   bc,18
        add  hl,bc
        call STKNUM
        call FPTOBC     ;BC=copy length
        pop  de
        pop  af
        pop  hl
        jr   nz,LOWER   ;jump if init string set
CHUNK2: push hl
        sbc  hl,de      ;from - to
        pop  hl
        jr   c,HIGHER
LOWER:  ldir            ;from > to -or- initialisation string specified
        ret
HIGHER: add  hl,bc      ;from < to
        dec  hl         ;HL=end of from chunk
        push hl
        ex   de,hl
        add  hl,bc
        dec  hl
        ex   de,hl      ;DE=end of to chunk
        pop  hl
        lddr
        ret

LABELS0:defw INITSR
        defw FIND
        defw FILL
        defw COPY